/*
 * Copyright 2013 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.awk.nano.statement;

import java.util.Collection;

import net.morilib.awk.nano.AwkReturnException;
import net.morilib.awk.nano.expr.AwkExpression;
import net.morilib.awk.nano.io.AwkFiles;
import net.morilib.awk.nano.namespace.AwkNamespace;
import net.morilib.awk.nano.value.AwkUndefined;
import net.morilib.awk.nano.value.AwkValue;

/**
 * 複文の中間表現です。
 *
 *
 * @author MORIGUCHI, Yuichiro 2013/04/14
 */
public class AwkSequence extends AwkExpression {

	private AwkExpression[] exprs;

	/**
	 * 中間表現を生成します。
	 * 
	 * @param exprs 中間表現の並び
	 */
	public AwkSequence(Collection<AwkExpression> exprs) {
		this.exprs = exprs.toArray(new AwkExpression[0]);
	}

	@Override
	public AwkValue eval(AwkNamespace ns, AwkFiles o) {
		AwkValue v = AwkUndefined.UNDEF;

		try {
			for(AwkExpression e : exprs) {
				v = e.eval(ns, o);
			}
			return v;
		} catch(AwkReturnException e) {
			return e.getValue();
		}
	}

	public void compileInternally(AwkExpressionMachine.Builder b,
			Object brk, Object cnt) {
		for(AwkExpression e : exprs) {
			e.compileInternally(b, brk, cnt);
		}
	}

}
